CLS
PRINT "EDINT"
PRINT
PRINT "READ IN PM2.5 INTERVAL DATA AND EDIT."
PRINT "BUILDS A PRINT FILE WITH TOTALS FOR EACH"
PRINT "DAY AND ERROR FLAGS."
'
' DAYS IN MONTH
'
DIM SITE$(30, 4)
DIM DMON(12)
DMON(1) = 31: DMON(2) = 28: DMON(3) = 31: DMON(4) = 30
DMON(5) = 31: DMON(6) = 30: DMON(7) = 31: DMON(8) = 31
DMON(9) = 30: DMON(10) = 31: DMON(11) = 30: DMON(12) = 31
'
OLDYEAR = -9999
'
'
' READ IN SITE DATA.
'
OPEN "I", #1, "\PM25DATA\SITES.TXT"
I = -1
40 I = I + 1
IF I > 30 THEN PRINT "TOO MANY SITES, CHANGE 'DIM SITE$(30,4)' STATEMENT."
IF EOF(1) THEN CLOSE 1: NUMSITES = I - 1: GOTO 50
'
' AIRS ID
'
INPUT #1, SITE$(I, 0)
'
' SAMPLER
'
IF EOF(1) THEN PRINT "ERROR IN SITE FILE": END
INPUT #1, SITE$(I, 1)
'
' POC
'
IF EOF(1) THEN PRINT "ERROR IN SITE FILE": END
INPUT #1, SITE$(I, 2)
'
' METHOD
'
IF EOF(1) THEN PRINT "ERROR IN SITE FILE": END
INPUT #1, SITE$(I, 3)
'
' FREQ
'
IF EOF(1) THEN PRINT "ERROR IN SITE FILE": END
INPUT #1, SITE$(I, 4)
'
GOTO 40
'
50 FOR I = 0 TO NUMSITES
FOR J = 0 TO 4
PRINT SITE$(I, J);
IF J < 4 THEN PRINT ", ";
NEXT J
PRINT
NEXT I
'
INPUT "SAMPLER NUMBER (5 DIGITS)"; SAM$
PATH$ = "\PM25DATA\" + SAM$
INPUT "WANT RAW DIRECTORY (Y/N)"; QXRAW$
IF QXRAW$ = "Y" OR QXRAW$ = "y" THEN PATH$ = PATH$ + "\RAW"
CHDIR PATH$
FILES
'
INPUT "INTERVAL FILE NAME"; FILE$
'IF LEN(FILE$) = 2 THEN FILE$ = SAM$ + "I" + FILE$ + ".TXT"
'PRINT "FILE="; FILE$
'
INPUT "OUTPUT PRINT FILE NAME"; F2$
OPEN "O", #2, F2$
'
' PRINT HEADER ON OUTPUT FILE.
'
PRINT #2, "SAMPLER="; SAM$; "  F=FLOW ERROR, T=TEMPERATURE ERROR"
PRINT #2, "                 ------------- FLOW --------------  ----- TEMP --------"
PRINT #2, "DATE       #RECS #0   #16.7  #>5%&>0 AVERAGE #<=5%  #DIFF>5  SUMDIF 30M"
PRINT #2, "---------- ----- ---- -----  ------- ------- -----  -------  ----------"
          FORMAT$ = " ##### #### #####  #######  ###.## #####  ####     ###.#"
'
' START AND END DATES.
'
'INPUT "START YEAR (YYYY) OR ALL"; QYEAR1$
'IF QYEAR1$ = "all" THEN QYEAR1$ = "ALL"
QYEAR1$ = "ALL"
IF QYEAR1$ = "ALL" THEN 60
'
QYEAR1# = VAL(QYEAR1$)
INPUT "START MONTH"; QMONTH1#
INPUT "START DAY"; QDAY1#
INPUT "END YEAR (YYYY)"; QYEAR2#
INPUT "END MONTH"; QMONTH2#
INPUT "END DAY"; QDAY2#
QDATE1# = QYEAR1# * 10000# + QMONTH1# * 100# + QDAY1#
QDATE2# = QYEAR2# * 10000# + QMONTH2# * 100# + QDAY2#

'
60 DONEKEY = 0
OPEN "I", #1, FILE$
IF EOF(1) THEN PRINT "ERROR, NOTHING IN FILE": CLOSE 1: CLOSE 2: END
LINE INPUT #1, LL$
IF LEN(LL$) > 20 THEN PRINT "ERROR, 1ST LINE>20": CLOSE 2: END
PRINT "IGNORE-"; LL$
'
' READ IN DATA
'
100 IF EOF(1) THEN DONEKEY = 1: CLOSE 1: GOTO 163
INPUT #1, DATE5$
'
' CHECK FOR A HEADER RECORD.
'
IF LEFT$(DATE5$, 4) = "2025" AND RIGHT$(DATE5$, 1) = "I" THEN 100
'
IF EOF(1) THEN DONEKEY = 1: CLOSE 1: GOTO 163
INPUT #1, TIME5$
IF EOF(1) THEN DONEKEY = 1: CLOSE 1: GOTO 163
INPUT #1, AMBTEMP$
IF EOF(1) THEN DONEKEY = 1: CLOSE 1: GOTO 163
INPUT #1, FILTEMP$
IF EOF(1) THEN DONEKEY = 1: CLOSE 1: GOTO 163
INPUT #1, PRES$
IF EOF(1) THEN DONEKEY = 1: CLOSE 1: GOTO 163
INPUT #1, FLOW$
'
IF LEN(DATE5$) <> 10 THEN PRINT "ERROR DATE": GOSUB 180: INPUT XYZ$
YEAR = VAL(LEFT$(DATE5$, 4))
MONTH = VAL(MID$(DATE5$, 6, 2))
DAY = VAL(RIGHT$(DATE5$, 2))
'
' IF TIME IS 00:00, THEN 5 MINUTE TIME PERIOD ACTUALLY REFERS TO THE
' PREVIOUS DAY. THEREFORE,  SUBTRACT ONE DAY IN THIS CASE.
'
IF TIME5$ <> "00:00" THEN 160
IF DAY <> 1 THEN DAY = DAY - 1: GOTO 160
IF MONTH <> 1 THEN MONTH = MONTH - 1: GOSUB 2000: DAY = DMON(MONTH): GOTO 160
MONTH = 12: DAY = 31: YEAR = YEAR - 1
'
160 'PRINT YEAR; " "; MONTH; " "; DAY
'
' EXCLUDE ON DESIRED DATES.
'
IF QYEAR1$ = "ALL" THEN 161
XDATE# = YEAR * 10000# + MONTH * 100# + DAY
'PRINT XDATE#; QDATE1#; QDATE2#
IF XDATE# < QDATE1# OR XDATE# > QDATE2# THEN 100
'
' KEEP TOTALS FOR THE DAY
'
161 IF OLDYEAR = -9999 THEN 166
IF YEAR = OLDYEAR AND MONTH = OLDMONTH AND DAY = OLDDAY THEN 166
'
' A NEW DAY HAS BEEN HIT, PRINT STATS FOR OLD DAY.
'
163 IF NUMTOT <> 0 THEN AVFLOW = SUMFLOW / NUMTOT
IF NUMTOT = 0 THEN AVFLOW = 0
PRINT OLDYEAR; "/"; OLDMONTH; "/"; OLDDAY
'
FLAG$ = " "
IF NUMOUT > 0 THEN FLAG$ = " F"
IF AVFLOW > 0 AND AVFLOW < 16.4 THEN FLAG$ = " F"
IF AVFLOW > 17! THEN FLAG$ = " F"
IF MTOTDIFF > 32 THEN FLAG$ = FLAG$ + "T"
'
PRINT #2, USING "####"; OLDYEAR;
PRINT #2, "/";
PRINT #2, USING "##"; OLDMONTH;
PRINT #2, "/";
PRINT #2, USING "##"; OLDDAY;
'
'DAX$ = MID$(STR$(OLDYEAR), 4) + "/" + MID$(STR$(OLDMONTH), 2)
'DAX$ = DAX$ + "/" + MID$(STR$(OLDDAY), 2)
'PRINT #2, DAX$;
PRINT #2, USING FORMAT$; NUMTOT; NUM0; NUM16.7; NUMOUT; AVFLOW; NUMIN; NUMDIFTP; MTOTDIFF;
PRINT #2, FLAG$
PRINT " AVFL=";
PRINT USING "##.#"; AVFLOW;
PRINT " #0="; NUM0; " #16.7="; NUM16.7;
PRINT "#TOT="; NUMTOT; "#FL>0 & OUT="; NUMOUT;
PRINT "#TP>5="; NUMDIFTP
'
IF DONEKEY <> 1 THEN 165
CLOSE 2
PRINT "PRINT FILE="; F2$
INPUT "ALL DONE, RUN AGAIN (Y/N)"; QAGAIN$
IF QAGAIN$ = "Y" OR QAGAIN$ = "y" THEN RUN
END
'
'164 INPUT "END OF FILE, 'Y' <ENTER>"; XYZ$
'IF XYZ$ <> "Y" AND XYZ$ <> "y" THEN 164
'END
'
' ZERO DAILY VALUES IN PREP FOR NEXT DAY.
'
165 NUM0 = 0: NUM16.7 = 0: NUMOUT = 0: NUMTOT = 0: SUMFLOW = 0: AVFLOW = 0
NUMDIFTP = 0: NUMIN = 0: SUMDIFTP = 0: PRESOUT = 0: MTOTDIFF = 0
166 FLOW = VAL(FLOW$)
IF FLOW <= 0 THEN NUM0 = NUM0 + 1: GOTO 170
IF FLOW = 16.7 THEN NUM16.7 = NUM16.7 + 1
IF FLOW < 15.84 OR FLOW > 17.5 THEN NUMOUT = NUMOUT + 1
170 NUMTOT = NUMTOT + 1
IF FLOW >= 15.84 AND FLOW <= 17.5 THEN NUMIN = NUMIN + 1
SUMFLOW = SUMFLOW + FLOW
GOTO 182
'
' SUBROUTINE TO PRINT A RECORD.
'
180 PRINT FILE$; "  "; DATE5$; " "; TIME5$; " "; AMBTEMP$; " ";
PRINT FILTEMP$; " "; PRES$; " "; FLOW$;
RETURN
'
182 PRES = VAL(PRES$)
IF PRES < 600 OR PRES > 800 THEN PRESOUT = PRESOUT + 1
AMBTEMP = VAL(AMBTEMP$)
FILTEMP = VAL(FILTEMP$)
DIFF = FILTEMP - AMBTEMP
'IF DIFF > 5 THEN PRINT "*** DIFF TEMPS > 5 ***, DIFF="; : PRINT USING "###.#"; DIFF
IF DIFF > 5 THEN NUMDIFTP = NUMDIFTP + 1: SUMDIFTP = SUMDIFTP + DIFF
'
' CHECK A RUNNING TOTAL OF LAST 6 TEMP DIFFERENCES.
'
D6 = D5: D5 = D4: D4 = D3: D3 = D2: D2 = D1: D1 = DIFF
TOTDIFF = D1 + D2 + D3 + D4 + D5 + D6
IF TOTDIFF > MTOTDIFF THEN MTOTDIFF = TOTDIFF
'
FLOW = VAL(FLOW$)
IF FLOW <= 0 THEN 220
'
200 'IF FLOW < 15.84 OR FLOW > 17.5 THEN PRINT "*** FLOW OUT ***": GOSUB 180
220 CNT = CNT + 1
'
' SAVE DAY IN ORDER TO KNOW IF NEXT IS NEW DAY.
'
OLDYEAR = YEAR: OLDMONTH = MONTH: OLDDAY = DAY
IF CNT < 15 THEN 100
'INPUT XYZ$
CNT = 0
GOTO 100

'
' SUBROUTUNE TO DETERMINE HOW MANY DAYS IN FEBRUARY.
'
' GIVEN: MONTH AND YEAR
' FIND SET DMON(2)
'
2000 DMON(2) = 28
IF YEAR MOD 4 = 0 THEN DMON(2) = 29
'PRINT "DMON(2)="; DMON(2)
RETURN


